
CoCoA-5 - Feature #368

port SmithNormalForm (CoCoA-4)package to CoCoA-5

11 Jun 2013 18:33 - Anna Maria Bigatti

Status: In Progress Start date: 11 Jun 2013

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 10%

Category: CoCoA-4 function to be added Estimated time: 0.00 hour

Target version: CoCoA-5.4.2 Spent time: 1.35 hour

Description

Related issues:

Related to CoCoA-5 - Support #242: CoCoA-5 Projects for students (e.g. credit... In Progress 28 Sep 2012

Related to CoCoALib - Feature #1001: CoCoALib: ideas for student projects In Progress 19 Jan 2017

History

#1 - 02 Apr 2014 17:34 - Anna Maria Bigatti

- Target version set to CoCoA-5.1.0 Easter14

#2 - 09 Apr 2014 15:54 - John Abbott

- Target version changed from CoCoA-5.1.0 Easter14 to CoCoA-5.1.1 Seoul14

#3 - 22 Jul 2014 09:30 - Anna Maria Bigatti

- Assignee set to Anna Maria Bigatti

- Target version changed from CoCoA-5.1.1 Seoul14 to CoCoA-5.?.?

#4 - 26 Jan 2018 15:23 - John Abbott

- Status changed from New to In Progress

- Target version changed from CoCoA-5.?.? to CoCoA-5.2.4

- % Done changed from 0 to 10

Anna says she has "cleaned up" the original CoCoA-4 code so that CoCoA-5 accepts it.

The code is in MatNormalForm.cpkg5 (original file was matrixnormalform.cpkg).

The package exports two names Smith and SmithFactor.

There is no entry in the CoCoA-5 documentation.

I would prefer SNF or SmithNormalForm rather than just Smith (or smith).

The code does not run properly.  I got what I believe to be an infinite loop with the following input (given to a fresh CoCoA-5):

M := mat(ZZ,[[random(-9,9) | j in 1..4] | i in 1..4]);

Smith(M);

The matrix M above is

matrix(ZZ,

 [[2, -8, -2, -1],

  [-1, 6, -1, 4],

  [-2, -1, -7, 0],

  [-2, -3, -7, -3]])
#5 - 26 Jan 2018 15:27 - John Abbott

More failing examples:

matrix(ZZ,

 [[6, -9, 0],

  [2, -2, 0],

  [6, -9, -4]])

 

matrix(ZZ,

 [[6, -8],

  [3, -6]])

 

matrix(ZZ,

 [[4, 2],

  [-3, 0]])

 

This one is diagonal, but still fails!

matrix(ZZ,

  [[2, 0],

   [0, 5]])

 

CONFIRMED 2021-03-15  the examples above take too long (or infinite loop)
#6 - 26 Jan 2018 15:28 - John Abbott

This should be ported to CoCoALib (once it has been corrected).  It would surely be faster ;-)

#7 - 25 Jul 2018 15:31 - John Abbott

- Target version changed from CoCoA-5.2.4 to CoCoA-5.3.0

#8 - 01 Oct 2019 14:21 - John Abbott

- Target version changed from CoCoA-5.3.0 to CoCoA-5.4.0

I think Florian had done some implementing; perhaps we can delegate to him?

#9 - 15 Mar 2021 11:02 - John Abbott

The current version of the code needs to be improved:

/**/ M := mat(ZZ,[[PowerMod(i,j-1,NextPrime(999)) | i in 1..20] | j in 1..20]);

/**/ MM := Smith(M);

--> ERROR: Too many nested scopes

#10 - 19 Mar 2021 14:56 - John Abbott

- Related to Support #242: CoCoA-5 Projects for students (e.g. crediti F and tesi) added

#11 - 19 Mar 2021 14:56 - John Abbott

- Related to Feature #1001: CoCoALib: ideas for student projects added

#12 - 04 Nov 2021 23:27 - John Abbott

- Target version changed from CoCoA-5.4.0 to CoCoA-5.4.2

#13 - 22 Jan 2024 10:37 - John Abbott

JAA has some new code from Passau which should be in integrated...
